from urllib.parse import urljoin

from communication_handler.api_clients.http_client.client import Client


class ITLBClient(object):
    """IT Load Balancer Client Class.

    This class serves as a wrapper for the API endpoints offered by the Catalyst
    IT Load Balancer. It is utilized by the DCMC Master Client of the source DC.

    Methods
    -------
    migration_update(vc_tag, status)
        Inform the ITLB of the migration status

    """
    def __init__(self, itlb_host_url):
        """ITLBClient Class Constructor.

        Parameters
        ----------
        itlb_host_url : str
            The host url of the IT Load Marketplace Connector

        """
        self.__client = Client(verify_ssl_cert=False)
        self.__url = itlb_host_url
        self.__headers = {
            'Accept': 'application/json',
            'Content-Type': 'application/json'
        }

    def migration_update(self, vc_tag, migration_status):
        """Inform ITLB about the status of the requested migration.

        This service is used by the DCMC Master Client of the source DC in order
        to report the status of the requested migration to the Energy Aware IT
        Load Balancer.

        Parameters
        ----------
        vc_tag : str
            The VC tag as it has been generated by the VCG
        migration_status : {'pending', 'rejected', 'success', 'failed'}
            The updated status of the migration

        Returns
        -------
        Response
            A Response object of the issued request

        Examples
        --------
        >>> from communication_handler import config
        >>> from communication_handler.api_clients.itlb_api import ITLBClient
        >>> itlb = ITLBClient(config.ITLB_HOST_URL)
        >>> vc_tag = '0x57f4a457f846c530ad7c2e060df12034fdd4a3949880e2162805b5cd0bf1d2da'
        >>> migration_status = 'success'
        >>> response = itlb.migration_update(vc_tag, migration_status)
        >>> response.status_code
        202

        """
        url = urljoin(self.__url, 'migration')
        payload = {'vc_tag': vc_tag, 'status': migration_status}
        response = self.__client.post(url=url, headers=self.__headers, payload=payload)
        return response
